//FLOATLIB -- an excuse to make floats work in console :^)
local function findPoint(s)
    local funny = string.find(s, ".", 1, true)
    if (funny ~= nil) then return (funny) else return -1 end
end

rawset(_G, "calculatePower", function(base, powerRaised)
    if (powerRaised < 0) then return 1 end
    
    if (powerRaised != 0)
        return (base * calculatePower(base, powerRaised-1));
    else
        return 1;
    end
end)

rawset(_G, "floatToFrac", function(s, warn)
	if (s == nil) then return 0 end
    local pointLoc = findPoint(s);
	local subbed = string.sub(s, pointLoc+1);
    local f2f = 1;
	local funnier = string.find(subbed, "0", 1, true);
    f2f = ((funnier == nil) and 10 or 1)
	if (pointLoc == -1) then return (tonumber(s)*100) end
    local fs1 = string.sub(s, 1, pointLoc-1);
    local fs2 = string.sub(s, pointLoc+1);
    local fallbackNum = nil;
    local fs1l = string.len(fs1);
    local fs2l = string.len(fs2);
    local tenFactor = (((fs1l-1) > 0) and calculatePower(10, (fs1l-1)) or 1);
    local f2factor = ((fs2l==1) and f2f or 1)

    local f2n = tonumber(fs2);
    local f2ex = calculatePower(10, (fs2l-2))
    local isOne = ((fs1l == 1) and 1 or 0)
    local f2ex2 = calculatePower(10, ((fs2l+isOne)-3))
    

    if (f2ex2 == 0) then f2ex2 = 1 end

    if (fs2l > 2) 
        if (warn == true) print("\x82".."WARNING: ".."\x80".."Float is outside of a tenths value. Results may be inaccurate.") end 
        if (fs1l > 2)
            fallbackNum = ((tonumber(fs1)*calculatePower(10, (fs2l+1)))+(f2n*f2ex))/100
        else
            fallbackNum = (((tonumber(fs1)*calculatePower(10, (fs2l)))+(f2n))/tenFactor)/(f2ex2)
        end
    end
	
	

    local fs1t = (tonumber(fs1)*100)
    local fs2t = (tonumber(fs2)*f2factor)
    local fNum = ((fallbackNum == nil) and (fs1t+fs2t) or ((fallbackNum)))
    return fNum;
end)